precision highp float;

in vec3 position;

uniform mat4 cameraMatrix;
uniform mat4 modelMatrix;

out vec4 screenPosition;

void main()
{
	screenPosition = cameraMatrix * modelMatrix * vec4(position, 1.0);

	if (screenPosition.z / screenPosition.w > 1.0)
		screenPosition.z = screenPosition.w;

	gl_Position = screenPosition;
}