//Matrix Definitions
uniform mat4 modelMatrix;
uniform mat4 cameraMatrixArray[3];
uniform mat4 inverseCameraMatrix;

//Material Definitions
uniform vec3 diffuseColor;
uniform vec3 specularColor;
uniform vec3 emittingColor;
uniform float specularHardness;

uniform sampler2D diffuseTexture;
uniform sampler2D normalTexture;

uniform bool isShadeless;
uniform float opacity;


//Structs for data passing between stages
struct Vertex
{
	vec4 position;
	vec4 normal;
	vec2 texCoord;
	vec4 tangent;
};

struct VertexFragment
{
	vec4 position;
	vec4 ndc;
	vec3 normal;
	vec2 texCoord;
	vec4 tangent;
	vec3 bitangent;
};

struct FragmentIllumination
{
	vec3 normal;
	float hardness;
	vec3 diffuse;
	vec3 specular;
	vec3 emitting;
	float opacity;
};