precision highp float;

#include "material.glsl"			// This include is handled in the shaderloader
#line 4 4

in VertexFragment vertexData;		// Input from vertex stage

layout(location = 0) out vec4 fragNormal;
layout(location = 1) out vec3 fragTangent;
layout(location = 2) out float fragDepth;

FragmentIllumination fragment(VertexFragment fragment);		// Prototype for user function

void main()
{
	VertexFragment inVertex = vertexData;
	inVertex.position /= inVertex.position.w;
	inVertex.ndc /= inVertex.ndc.w;
	inVertex.normal = normalize(inVertex.normal);
	inVertex.tangent = normalize(inVertex.tangent);

	FragmentIllumination fragMaterial = fragment(inVertex);

	vec3 baseVector = vec3(0,1,0);
	if (abs(dot(baseVector, fragMaterial.normal)) > 0.0)
	{
		fragTangent = normalize(cross(baseVector, fragMaterial.normal));
	}
	else
	{
		baseVector = vec3(1,0,0);
		fragTangent = normalize(cross(baseVector, fragMaterial.normal));
	}

	fragNormal = vec4(normalize(fragMaterial.normal), fragMaterial.hardness);
	fragDepth = gl_FragCoord.z;
}