precision highp float;

#include "material.glsl"			// This include is handled in the shaderloader
#line 4 4

layout (triangles) in;
layout(triangle_strip, max_vertices = 3) out;

in Vertex geomData[];
out VertexFragment vertexData;

VertexFragment vertex(Vertex vertex, mat4 cameraMatrix);		//Prototype for user function

void main()
{
	mat4 camMatrix;

	VertexFragment v[3];

	v[0] = vertex(geomData[0], cameraMatrixArray[0]);
	v[1] = vertex(geomData[1], cameraMatrixArray[0]);
	v[2] = vertex(geomData[2], cameraMatrixArray[0]);

	vec3 triangleNormal = abs(cross(v[1].position.xyz - v[0].position.xyz, v[2].position.xyz - v[0].position.xyz));

	if (triangleNormal.x > triangleNormal.y && triangleNormal.x > triangleNormal.z)
		camMatrix = cameraMatrixArray[0];
	else if (triangleNormal.y > triangleNormal.z)
		camMatrix = cameraMatrixArray[1];
	else
		camMatrix = cameraMatrixArray[2];

	for (int i = 0; i < 3; i++)
	{
		vertexData = v[i];
		vertexData.ndc = camMatrix * v[i].position;
		gl_Position = vertexData.ndc;
		EmitVertex();
	}

	EndPrimitive();
}