uint packSnorm3x10(vec3 _vector)
{
	vec3 v = round(clamp(_vector, -1.0, 1.0) * 512.0);
	uint result = 0;

	result = bitfieldInsert(result, int(v.x), 0, 10);
	result = bitfieldInsert(result, int(v.y), 10, 10);
	result = bitfieldInsert(result, int(v.z), 20, 10);

	return result;
}

vec3 unpackSnorm3x10(uint _value)
{
	int value = int(_value);
	vec3 result = vec3(
		float(bitfieldExtract(value, 0, 10)) / 512.0,
		float(bitfieldExtract(value, 10, 10)) / 512.0,
		float(bitfieldExtract(value, 20, 10)) / 512.0
		);
	return clamp(result, -1.0, 1.0);
}

struct LinkBufferEntry
{
	uint children;
	uint xplus;
	uint xminus;
	uint yplus;
	uint yminus;
	uint zplus;
	uint zminus;
};

struct DeferredBufferEntry
{
	uint pos;
	uint normal;
	uint emitting;
	uint diffuse;
	uint specular;
	uint opacityHardness;
};

int intMod(int _value, int _mod)
{
	return _value - (_value / _mod) * _mod;
}

ivec3 addr3D(int _id)
{
	ivec3 addr = ivec3(
		intMod(_id, 512),
		intMod(_id, 512*512) / 512,
		_id / (512*512)
	);

	return addr * 3;
}