#include "octree_common.glsl"

#line 3 3

layout (std430, binding = 1) buffer linkBuffer
{
	LinkBufferEntry entry[];
};

void main()
{
	int id = 1 + gl_VertexID * 8 + gl_InstanceID;
	LinkBufferEntry e = entry[id];

	if (e.children == 0U)
		return;

	//X Minus
	uint neighborPtr = entry[e.xminus].children * sign(e.xminus);
	if (neighborPtr != 0U)
	{
		entry[e.children + 0].xminus = (neighborPtr + 4);
		entry[e.children + 1].xminus = (neighborPtr + 5);
		entry[e.children + 2].xminus = (neighborPtr + 6);
		entry[e.children + 3].xminus = (neighborPtr + 7);
	}

	//X Plus
	neighborPtr = entry[e.xplus].children * sign(e.xplus);
	if (neighborPtr != 0U)
	{
		entry[e.children + 4].xplus = (neighborPtr + 0);
		entry[e.children + 5].xplus = (neighborPtr + 1);
		entry[e.children + 6].xplus = (neighborPtr + 2);
		entry[e.children + 7].xplus = (neighborPtr + 3);
	}

	//Y Minus
	neighborPtr = entry[e.yminus].children * sign(e.yminus);
	if (neighborPtr != 0U)
	{
		entry[e.children + 0].yminus = (neighborPtr + 2);
		entry[e.children + 1].yminus = (neighborPtr + 3);
		entry[e.children + 4].yminus = (neighborPtr + 6);
		entry[e.children + 5].yminus = (neighborPtr + 7);
	}

	//Y Plus
	neighborPtr = entry[e.yplus].children * sign(e.yplus);
	if (neighborPtr != 0U)
	{
		entry[e.children + 2].yplus = (neighborPtr + 0);
		entry[e.children + 3].yplus = (neighborPtr + 1);
		entry[e.children + 6].yplus = (neighborPtr + 4);
		entry[e.children + 7].yplus = (neighborPtr + 5);
	}

	//Z Minus
	neighborPtr = entry[e.zminus].children * sign(e.zminus);
	if (neighborPtr != 0U)
	{
		entry[e.children + 0].zminus = (neighborPtr + 1);
		entry[e.children + 2].zminus = (neighborPtr + 3);
		entry[e.children + 4].zminus = (neighborPtr + 5);
		entry[e.children + 6].zminus = (neighborPtr + 7);
	}

	//Z Plus
	neighborPtr = entry[e.zplus].children * sign(e.zplus);
	if (neighborPtr != 0U)
	{
		entry[e.children + 1].zplus = (neighborPtr + 0);
		entry[e.children + 3].zplus = (neighborPtr + 2);
		entry[e.children + 5].zplus = (neighborPtr + 4);
		entry[e.children + 7].zplus = (neighborPtr + 6);
	}
}