#include "octree_common.glsl"

#line 3 3

out vec4 fragColor;

in vec3 color;
in vec3 texCoord;
in flat int fragId;

uniform sampler3D brickTexture;

uniform uint level;
uniform uint leafLevel;

void main()
{
	if (level == leafLevel)
	{
		fragColor = vec4(color, 1.0);
	}
	else
	{
		//Draw values from 3D texture
		ivec3 texSize = textureSize(brickTexture, 0);
		vec3 texelSize = 1.0 / vec3(texSize);

		vec3 brickCoord = (addr3D(fragId) + texCoord * 2.0) * texelSize + texelSize * 0.5;
		//float opacity = texture(brickTexture, brickCoord).x;
		vec4 data = texture(brickTexture, brickCoord);

		fragColor = vec4(data.rgb, 1);
	}
}