precision highp float;

layout (points) in;
layout(triangle_strip, max_vertices = 6) out;

uniform vec2 size;

in vec4 vPosition[];

out vec2 texCoord;

void main()
{
	vec3 pos = gl_in[0].gl_Position.xyz / gl_in[0].gl_Position.w;
	
	gl_Position = vec4(pos.x - size.x, pos.y - size.y, pos.z, 1.0);
	texCoord = vec2(0.0, 0.0);
	EmitVertex();

	gl_Position = vec4(pos.x + size.x, pos.y - size.y, pos.z, 1.0);
	texCoord = vec2(1.0, 0.0);
	EmitVertex();

	gl_Position = vec4(pos.x + size.x, pos.y + size.y, pos.z, 1.0);
	texCoord = vec2(1.0, 1.0);
	EmitVertex();

	EndPrimitive();

	gl_Position = vec4(pos.x - size.x, pos.y - size.y, pos.z, 1.0);
	texCoord = vec2(0.0, 0.0);
	EmitVertex();

	gl_Position = vec4(pos.x + size.x, pos.y + size.y, pos.z, 1.0);
	texCoord = vec2(1.0, 1.0);
	EmitVertex();

	gl_Position = vec4(pos.x - size.x, pos.y + size.y, pos.z, 1.0);
	texCoord = vec2(0.0, 1.0);
	EmitVertex();

	EndPrimitive();
}