#line 1 1

precision highp float;

in vec2 colorTexUV;

layout(location = 0) out vec3 fragColor;

uniform layout(binding = 0) sampler2D avgLumTexture;
uniform layout(binding = 1) sampler2D colorTexture;

uniform float middleGray;
uniform float maxLuminance;

const vec3 LUM_CONVERT = vec3(0.299f, 0.587f, 0.114f);

void main()
{
	float avgLum = max(texture(avgLumTexture, vec2(0.5, 0.5)).r, 0.00001);
	vec3 color = texture(colorTexture, vec2(colorTexUV.xy)).rgb;

	float curLum = dot(color, LUM_CONVERT);

	float lumScale = (curLum * middleGray) / avgLum;
	float lumMapped = (lumScale * (1.0 + (lumScale / (maxLuminance * maxLuminance)))) / (1.0 + lumScale);

	fragColor = lumMapped * color;
}