precision highp float;

uniform layout(binding = 1) sampler2D frameTexture;
uniform layout(binding = 0) sampler2D lastLuminanceTexture;

uniform int mipmapLevel;
uniform float adaptionSpeed;
uniform float frameTime;

const vec3 LUM_CONVERT = vec3(0.299f, 0.587f, 0.114f);

layout(location = 0) out float fragColor;

void main()
{
	vec3 frameColor = textureLod(frameTexture, vec2(0.5, 0.5), mipmapLevel).rgb;
	float curLum = dot(frameColor, LUM_CONVERT);

	float lastLum = texture(lastLuminanceTexture, vec2(0.5, 0.5)).r;
	

	fragColor = lastLum + (curLum - lastLum) * (1.0 - exp(-frameTime * adaptionSpeed));
}